// CarController.cpp
//THIS FILE SHOULD BE CHANGED, SEE THE CONSTRUCTOR BELOW

#include "CarController.h"
#include "Sensor.h"
#include <iostream>
#include <ctime> 

using namespace std;

CarController::CarController(){
	state = safe;
	wheels.push_back(new Wheel(new Sensor(), WheelId::FR));
	wheels.push_back(new Wheel(new Sensor(), WheelId::FL));
        // THE TWO REAR WHEELS NEED TO BE CONNECTED TO THE NEW SENSORS 
        // USING THE ADAPTER
	wheels.push_back(new Wheel(new Sensor(), WheelId::RR));
	wheels.push_back(new Wheel(new Sensor(), WheelId::RL));
	srand(time(0));
}

void CarController::start(){
	cout << "in CarController::start()" << state << endl;
	int pressure;
	while (state == safe){
		for (Wheel* w : wheels){
			pressure = w->pressureSensor->getPressure();
			if (pressure > 240 || pressure < 10) {
				cout << "abnormal pressure: " << pressure << endl;
				state = unsafe;
			}
		}
	}
	cout << "Car usafe to drive!" << endl;
}
CarController::~CarController(){
}

Wheel::Wheel(Sensor* newPressureSensor, WheelId newWid) : pressureSensor(newPressureSensor), wid(newWid) {
};

